program iterative_inversion
! experiments with matrix iterative inversion
  implicit none
  integer, parameter :: n=4
  real, dimension(n,n) :: a, x, x_old, x_start
  real :: tol, err
  integer :: i, j, max_iter
  
  open(21,FILE='input.dat',FORM='unformatted',STATUS='old')
  read(21) a
  read(21) x_start
  read(21) tol,max_iter
  close(21)

  write(*,'("Matrix to invert:")')
  write(*,100) a
  write(*,'(/,"Start matrix:")')
  write(*,100) x_start
  write(*,'(/,A," ",E15.7)') 'Tolerance:',tol
  write(*,'(/,(A," ",I11," "))') 'Max iteration number:', max_iter 

  x_old = x_start
  do i=1,max_iter
    x = 2.0*x_old - matmul(x_old,matmul(a,x_old))
    err = maxval(abs(x - x_old))
    if (err < tol) exit
    x_old = x
  end do

  open(22,FILE='itinv.dat',FORM='unformatted')
  write(22) a
  write(22) x_start
  write(22) tol,max_iter
  write(22) i
  write(22) x
  close(22)

  write(*,'("Final matrix:")')
  write(*,100) x
  write(*,*)
  write(*,'("a*a^-1:")')
  write(*,100) matmul(a,x)

  open(22,FILE='element-wise.dat',FORM='unformatted')
  do j=1, n
    do i=1, n
      write(22) x(i,j)
    end do
  end do
  close(22)

  open(22,FILE='column-wise.dat',FORM='unformatted')
  do j=1, n
    write(22) (x(i,j), i=1, n)
  end do
  close(22)

  open(22,FILE='block.dat',FORM='unformatted')
  write(22) ((x(i,j), i=1,n), j=1,n)
  close(22) 

100 format(4(E15.7," "))
end program iterative_inversion
